package com.gootrip.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.filechooser.FileFilter;

/**
 * зװһЩõļ
 * зǾ̬Ҫɴʵ
 * Ϊɴʵ췽Ϊprivate͵ġ
 * @since  1.0
 */

public class FileUtil {
  /**
   * ˽й췽ֹʵΪ಻Ҫʵ
   */
  private FileUtil() {

  }

  /**
   * ޸ļʱ䡣
   * ļ򴴽ļ
   * <b>ĿǰΪʽȶҪǷЩϢЩϢǷڿС</b>
   * @param file Ҫ޸ʱļ
   * @since  1.0
   */
  public static void touch(File file) {
    long currentTime = System.currentTimeMillis();
    if (!file.exists()) {
      System.err.println("file not found:" + file.getName());
      System.err.println("Create a new file:" + file.getName());
      try {
        if (file.createNewFile()) {
          System.out.println("Succeeded!");
        }
        else {
          System.err.println("Create file failed!");
        }
      }
      catch (IOException e) {
        System.err.println("Create file failed!");
        e.printStackTrace();
      }
    }
    boolean result = file.setLastModified(currentTime);
    if (!result) {
      System.err.println("touch failed: " + file.getName());
    }
  }

  /**
   * ޸ļʱ䡣
   * ļ򴴽ļ
   * <b>ĿǰΪʽȶҪǷЩϢЩϢǷڿС</b>
   * @param fileName Ҫ޸ʱļļ
   * @since  1.0
   */
  public static void touch(String fileName) {
    File file = new File(fileName);
    touch(file);
  }

  /**
   * ޸ļʱ䡣
   * ļ򴴽ļ
   * <b>ĿǰΪʽȶҪǷЩϢЩϢǷڿС</b>
   * @param files Ҫ޸ʱļ顣
   * @since  1.0
   */
  public static void touch(File[] files) {
    for (int i = 0; i < files.length; i++) {
      touch(files[i]);
    }
  }

  /**
   * ޸ļʱ䡣
   * ļ򴴽ļ
   * <b>ĿǰΪʽȶҪǷЩϢЩϢǷڿС</b>
   * @param fileNames Ҫ޸ʱļ顣
   * @since  1.0
   */
  public static void touch(String[] fileNames) {
    File[] files = new File[fileNames.length];
    for (int i = 0; i < fileNames.length; i++) {
      files[i] = new File(fileNames[i]);
    }
    touch(files);
  }

  /**
   * жָļǷڡ
   * @param fileName Ҫжϵļļ
   * @return ʱtrue򷵻false
   * @since  1.0
   */
  public static boolean isFileExist(String fileName) {
    return new File(fileName).isFile();
  }

  /**
   * ָĿ¼
   * ָĿ¼ĸĿ¼򴴽Ŀ¼ҪĸĿ¼
   * <b>ע⣺ܻڷfalseʱ򴴽ָĿ¼</b>
   * @param file ҪĿ¼
   * @return ȫɹʱtrue򷵻false
   * @since  1.0
   */
  public static boolean makeDirectory(File file) {
    File parent = file.getParentFile();
    if (parent != null) {
      return parent.mkdirs();
    }
    return false;
  }

  /**
   * ָĿ¼
   * ָĿ¼ĸĿ¼򴴽Ŀ¼ҪĸĿ¼
   * <b>ע⣺ܻڷfalseʱ򴴽ָĿ¼</b>
   * @param fileName ҪĿ¼Ŀ¼
   * @return ȫɹʱtrue򷵻false
   * @since  1.0
   */
  public static boolean makeDirectory(String fileName) {
    File file = new File(fileName);
    return makeDirectory(file);
  }

  /**
   * ָĿ¼еļ
   * ɾеļֻҪһļûбɾ᷵false
   * ɾɾĿ¼ݡ
   * @param directory ҪյĿ¼
   * @return Ŀ¼µļɹɾʱtrue򷵻false.
   * @since  1.0
   */
  public static boolean emptyDirectory(File directory) {
    boolean result = true;
    File[] entries = directory.listFiles();
    for (int i = 0; i < entries.length; i++) {
      if (!entries[i].delete()) {
        result = false;
      }
    }
    return result;
  }

  /**
   * ָĿ¼еļ
   * ɾеļֻҪһļûбɾ᷵false
   * ɾɾĿ¼ݡ
   * @param directoryName ҪյĿ¼Ŀ¼
   * @return Ŀ¼µļɹɾʱtrue򷵻false
   * @since  1.0
   */
  public static boolean emptyDirectory(String directoryName) {
    File dir = new File(directoryName);
    return emptyDirectory(dir);
  }

  /**
   * ɾָĿ¼еݡ
   * @param dirName ҪɾĿ¼Ŀ¼
   * @return ɾɹʱtrue򷵻false
   * @since  1.0
   */
  public static boolean deleteDirectory(String dirName) {
    return deleteDirectory(new File(dirName));
  }

  /**
   * ɾָĿ¼еݡ
   * @param dir ҪɾĿ¼
   * @return ɾɹʱtrue򷵻false
   * @since  1.0
   */
  public static boolean deleteDirectory(File dir) {
    if ( (dir == null) || !dir.isDirectory()) {
      throw new IllegalArgumentException("Argument " + dir +
                                         " is not a directory. ");
    }

    File[] entries = dir.listFiles();
    int sz = entries.length;

    for (int i = 0; i < sz; i++) {
      if (entries[i].isDirectory()) {
        if (!deleteDirectory(entries[i])) {
          return false;
        }
      }
      else {
        if (!entries[i].delete()) {
          return false;
        }
      }
    }

    if (!dir.delete()) {
      return false;
    }
    return true;
  }

  /**
   * гĿ¼еݣĿ¼еݡ
   * @param fileName ҪгĿ¼Ŀ¼
   * @return Ŀ¼ݵļ顣
   * @since  1.0
   */
  /*public static File[] listAll(String fileName) {
    return listAll(new File(fileName));
  }*/

  /**
   * гĿ¼еݣĿ¼еݡ
   * @param file ҪгĿ¼
   * @return Ŀ¼ݵļ顣
   * @since  1.0
   */
  /*public static File[] listAll(File file) {
    ArrayList list = new ArrayList();
    File[] files;
    if (!file.exists() || file.isFile()) {
      return null;
    }
    list(list, file, new AllFileFilter());
    list.remove(file);
    files = new File[list.size()];
    list.toArray(files);
    return files;
  }*/

  /**
   * гĿ¼еݣĿ¼еݡ
   * @param file ҪгĿ¼
   * @param filter 
   * @return Ŀ¼ݵļ顣
   * @since  1.0
   */
  public static File[] listAll(File file,
                               javax.swing.filechooser.FileFilter filter) {
    ArrayList list = new ArrayList();
    File[] files;
    if (!file.exists() || file.isFile()) {
      return null;
    }
    list(list, file, filter);
    files = new File[list.size()];
    list.toArray(files);
    return files;
  }

  /**
   * Ŀ¼еӵб
   * @param list ļб
   * @param filter 
   * @param file Ŀ¼
   */
  private static void list(ArrayList list, File file,
                           javax.swing.filechooser.FileFilter filter) {
    if (filter.accept(file)) {
      list.add(file);
      if (file.isFile()) {
        return;
      }
    }
    if (file.isDirectory()) {
      File files[] = file.listFiles();
      for (int i = 0; i < files.length; i++) {
        list(list, files[i], filter);
      }
    }

  }

  /**
   * ļURLַ
   * @param file ļ
   * @return ļӦĵURLַ
   * @throws MalformedURLException
   * @since  1.0
   * @deprecated ʵֵʱûע⵽File౾һtoURLļ·תΪURL
   *             ʹFile.toURL
   */
  public static URL getURL(File file) throws MalformedURLException {
    String fileURL = "file:/" + file.getAbsolutePath();
    URL url = new URL(fileURL);
    return url;
  }

  /**
   * ļ·õļ
   * @param filePath ļ··ҲǾ·
   * @return Ӧļ
   * @since  1.0
   */
  public static String getFileName(String filePath) {
    File file = new File(filePath);
    return file.getName();
  }

  /**
   * ļõļ·
   * @param fileName ļ
   * @return Ӧļ·
   * @since  1.0
   */
  public static String getFilePath(String fileName) {
    File file = new File(fileName);
    return file.getAbsolutePath();
  }

  /**
   * DOS/Windowsʽ·תΪUNIX/Linuxʽ·
   * ʵǽ·е"\"ȫΪ"/"ΪĳЩתΪַʽȽϷ㣬
   * ĳг̶˵"/""\"ʺΪ·ָDOS/WindowsҲ·ָ
   * @param filePath תǰ·
   * @return ת·
   * @since  1.0
   */
  public static String toUNIXpath(String filePath) {
    return filePath.replace('\\', '/');
  }

  /**
   * ļõUNIXļ·
   * @param fileName ļ
   * @return ӦUNIXļ·
   * @since  1.0
   * @see #toUNIXpath(String filePath) toUNIXpath
   */
  public static String getUNIXfilePath(String fileName) {
    File file = new File(fileName);
    return toUNIXpath(file.getAbsolutePath());
  }

  /**
   * õļ͡
   * ʵϾǵõļһ.Ĳ֡
   * @param fileName ļ
   * @return ļеͲ
   * @since  1.0
   */
  public static String getTypePart(String fileName) {
    int point = fileName.lastIndexOf('.');
    int length = fileName.length();
    if (point == -1 || point == length - 1) {
      return "";
    }
    else {
      return fileName.substring(point + 1, length);
    }
  }

  /**
   * õļ͡
   * ʵϾǵõļһ.Ĳ֡
   * @param file ļ
   * @return ļеͲ
   * @since  1.0
   */
  public static String getFileType(File file) {
    return getTypePart(file.getName());
  }

  /**
   * õļֲ֡
   * ʵϾ·еһ·ָĲ֡
   * @param fileName ļ
   * @return ļеֲ
   * @since  1.0
   */
  public static String getNamePart(String fileName) {
    int point = getPathLsatIndex(fileName);
    int length = fileName.length();
    if (point == -1) {
      return fileName;
    }
    else if (point == length - 1) {
      int secondPoint = getPathLsatIndex(fileName, point - 1);
      if (secondPoint == -1) {
        if (length == 1) {
          return fileName;
        }
        else {
          return fileName.substring(0, point);
        }
      }
      else {
        return fileName.substring(secondPoint + 1, point);
      }
    }
    else {
      return fileName.substring(point + 1);
    }
  }

  /**
   * õļеĸ·֡
   * ·ָЧ
   * ʱ""
   * ļ·ָβ򲻿Ǹ÷ָ"/path/"""
   * @param fileName ļ
   * @return ·ڻѾǸĿ¼ʱ""
   * @since  1.0
   */
  public static String getPathPart(String fileName) {
    int point = getPathLsatIndex(fileName);
    int length = fileName.length();
    if (point == -1) {
      return "";
    }
    else if (point == length - 1) {
      int secondPoint = getPathLsatIndex(fileName, point - 1);
      if (secondPoint == -1) {
        return "";
      }
      else {
        return fileName.substring(0, secondPoint);
      }
    }
    else {
      return fileName.substring(0, point);
    }
  }

  /**
   * õ·ָļ·״γֵλá
   * DOSUNIXķָԡ
   * @param fileName ļ·
   * @return ·ָ·״γֵλãûгʱ-1
   * @since  1.0
   */
  public static int getPathIndex(String fileName) {
    int point = fileName.indexOf('/');
    if (point == -1) {
      point = fileName.indexOf('\\');
    }
    return point;
  }

  /**
   * õ·ָļ·ָλú״γֵλá
   * DOSUNIXķָԡ
   * @param fileName ļ·
   * @param fromIndex ʼҵλ
   * @return ·ָ·ָλú״γֵλãûгʱ-1
   * @since  1.0
   */
  public static int getPathIndex(String fileName, int fromIndex) {
    int point = fileName.indexOf('/', fromIndex);
    if (point == -1) {
      point = fileName.indexOf('\\', fromIndex);
    }
    return point;
  }

  /**
   * õ·ָļ·ֵλá
   * DOSUNIXķָԡ
   * @param fileName ļ·
   * @return ·ָ·ֵλãûгʱ-1
   * @since  1.0
   */
  public static int getPathLsatIndex(String fileName) {
    int point = fileName.lastIndexOf('/');
    if (point == -1) {
      point = fileName.lastIndexOf('\\');
    }
    return point;
  }

  /**
   * õ·ָļ·ָλǰֵλá
   * DOSUNIXķָԡ
   * @param fileName ļ·
   * @param fromIndex ʼҵλ
   * @return ·ָ·ָλǰֵλãûгʱ-1
   * @since  1.0
   */
  public static int getPathLsatIndex(String fileName, int fromIndex) {
    int point = fileName.lastIndexOf('/', fromIndex);
    if (point == -1) {
      point = fileName.lastIndexOf('\\', fromIndex);
    }
    return point;
  }

  /**
   * ļеͲȥ
   * @param filename ļ
   * @return ȥͲֵĽ
   * @since  1.0
   */
  public static String trimType(String filename) {
    int index = filename.lastIndexOf(".");
    if (index != -1) {
      return filename.substring(0, index);
    }
    else {
      return filename;
    }
  }
  /**
   * õ·
   * ļĿ¼ӽڵʱļ
   * @param pathName Ŀ¼
   * @param fileName ļ
   * @return õļĿ¼·Ŀ¼²ڸļʱļ
   * @since  1.0
   */
  public static String getSubpath(String pathName,String fileName) {
    int index = fileName.indexOf(pathName);
    if (index != -1) {
      return fileName.substring(index + pathName.length() + 1);
    }
    else {
      return fileName;
    }
  }

  /**
   * Ŀ¼Ĵ
   * ָ֤·ãָ·ڣô·Ϊ༶·
   * @param path
   * @return ֵ
   * @since  1.0
   */
   public static final boolean pathValidate(String path)
   {
     //String path="d:/web/www/sub";
     //System.out.println(path);
     //path = getUNIXfilePath(path);

     //path = ereg_replace("^\\/+", "", path);
     //path = ereg_replace("\\/+$", "", path);
     String[] arraypath = path.split("/");
     String tmppath = "";
     for (int i = 0; i < arraypath.length; i++)
     {
       tmppath += "/" + arraypath[i];
       File d = new File(tmppath.substring(1));
       if (!d.exists()) { //SubĿ¼Ƿ
           System.out.println(tmppath.substring(1));
         if (!d.mkdir())
         {
           return false;
         }
       }
     }
     return true;
   }

   /**
    * ȡļ
    * ȡָļ
    * @param path ΪҪȡļľ·
    * @return жȡļݡ
    * @since  1.0
    */
   public static final String getFileContent(String path) throws IOException
   {
     String filecontent = "";
     try {
       File f = new File(path);
       if (f.exists()) {
         FileReader fr = new FileReader(path);
         BufferedReader br = new BufferedReader(fr); //BufferedReader󣬲ʵΪbr
         String line = br.readLine(); //ļȡһַ
         //ж϶ȡַǷΪ
         while (line != null) {
           filecontent += line + "\n";
           line = br.readLine(); //ļмȡһ
         }
         br.close(); //رBufferedReader
         fr.close(); //رļ
       }

     }
     catch (IOException e) {
       throw e;
     }
     return filecontent;
   }

   /**
    * ļ
    * @param pathҪļľ·
    * @param ļݡ
    * @return ֵ
    * @since  1.0
    */
   public static final boolean genModuleTpl(String path, String modulecontent)  throws IOException
   {

     path = getUNIXfilePath(path);
     String[] patharray = path.split("\\/");
     String modulepath = "";
     for (int i = 0; i < patharray.length - 1; i++) {
       modulepath += "/" + patharray[i];
     }
     File d = new File(modulepath.substring(1));
     if (!d.exists()) {
       if (!pathValidate(modulepath.substring(1))) {
         return false;
       }
     }
     try {
       FileWriter fw = new FileWriter(path); //FileWriter󣬲ʵfw
       //ַдļ
       fw.write(modulecontent);
       fw.close();
     }
     catch (IOException e) {
       throw e;
     }
     return true;
   }

   /**
    * ȡͼƬļչϵͳרã
    * @param picname ΪͼƬƼǰ·չ
    * @return ͼƬչ
    * @since  1.0
    */
   public static final String getPicExtendName(String pic_path)
   {
     pic_path = getUNIXfilePath(pic_path);
     String pic_extend = "";
     if (isFileExist(pic_path + ".gif"))
     {
       pic_extend = ".gif";
     }
     if (isFileExist(pic_path + ".jpeg"))
     {
       pic_extend = ".jpeg";
     }
     if (isFileExist(pic_path + ".jpg"))
     {
       pic_extend = ".jpg";
     }
     if (isFileExist(pic_path + ".png"))
     {
       pic_extend = ".png";
     }
     return pic_extend; //ͼƬչ
   }
   //ļ
   public static final boolean CopyFile(File in, File out) throws Exception {
       try {
           FileInputStream fis = new FileInputStream(in);
           FileOutputStream fos = new FileOutputStream(out);
           byte[] buf = new byte[1024];
           int i = 0;
           while ((i = fis.read(buf)) != -1) {
               fos.write(buf, 0, i);
           }
           fis.close();
           fos.close();
           return true;
       } catch (IOException ie) {
           ie.printStackTrace();
           return false;
       }
   }
   //ļ
   public static final boolean CopyFile(String infile, String outfile) throws Exception {
       try {
           File in = new File(infile);
           File out = new File(outfile);
           return CopyFile(in, out);
       } catch (IOException ie) {
           ie.printStackTrace();
           return false;
       }

   }
   /**
    * ͼƬ
    * @param id
    * @param dtime
    * @return
    */
   public static final int countPics(String id,String dtime,String extensions){
	   int counts = 0; 
	   
	   MyFileFilter mfilter = new MyFileFilter(extensions.split(","));
       PropsUtil pu = new PropsUtil();
       String PICROOT = pu.readSingleProps("DestinationsPICROOT").trim();
       String path = PICROOT + "/"+dtime.substring(0, 10) + "/";
       File lfile = new File(path);
       String filename;
       if(lfile.isDirectory()){
    	   File[] files = lfile.listFiles(mfilter);
    	   for(int i=0;i<files.length;i++){
    		   filename = files[i].getName();
    		   if((filename.indexOf(id + "_")==0)&&(filename.indexOf("_small")>-1))
    			   counts ++;
    	   }
    	   files = null;
       }
       filename = null;
       lfile = null;
       pu = null;
       mfilter = null;
    	   
	   return counts;
   }

}
